Player=Turbine.Gameplay.LocalPlayer:GetInstance();

VBarButton={}
	VBarButton.Window=Turbine.UI.Window()
	VBarButton.Window:SetVisible(true)
	VBarButton.Window.DragBar = Deusdictum.UI.DragBar( VBarButton.Window,"VBar")
	VBarButton.Window:SetPosition(Option.X,Option.Y)
	VBarButton.Window:SetSize(32,32)
	VBarButton.Window:SetOpacity(1)
	VBarButton.Window:SetMouseVisible(true)
	VBarButton.Window:SetBackground(0x410080ae)
	VBarButton.Window:SetStretchMode(1)
	VBarButton.Window:SetSize(32*Option.Scale,32*Option.Scale)
	
	VBarButton.Cover=Turbine.UI.Control()
	VBarButton.Cover:SetVisible(true)
	VBarButton.Cover:SetParent(VBarButton.Window)
	VBarButton.Cover:SetSize(32*Option.Scale,32*Option.Scale)
	VBarButton.Cover:SetMouseVisible(false)
	
	--self.Window.RotateStart = function () self:Rotate() end
	
	VBarButton.Window.DragEnable=function() VBarButton.Cover:SetMouseVisible(true) end
	VBarButton.Window.DragDisable=function() VBarButton.Cover:SetMouseVisible(false) end
	
	Player:RegisterForClickHandling(VBarButton.Window)
	
	VBarButton.Window.SizeChanged=function(sender,args)
		VBarButton.Cover:SetSize(32*Option.Scale,32*Option.Scale)
	end
		
	VBarButton.Cover.MouseDown=function(sender,args)
			
			if ( args.Button == Turbine.UI.MouseButton.Left ) then
				moving=true
				--Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Vitals, shown );
			end
			if ( args.Button == Turbine.UI.MouseButton.Right ) then
		
				local contextMenu = Turbine.UI.ContextMenu()
				contextMenu.items = contextMenu:GetItems()

				local option1 = Turbine.UI.MenuItem("Show text/percentage")
					contextMenu.SubMenuItems = option1:GetItems()
					local suboption1={}
						suboption1[1] = Turbine.UI.MenuItem("Text Curr/Max",true,Option.txt)
						suboption1[1].Click = function () Option.per=false Option.txt=true MoraleChanged() PowerChanged() Morale:SetFill(0.8) Power:SetFill(0.8) Morale:SetOpacity(1) Power:SetOpacity(1) end

						contextMenu.SubMenuItems:Add(suboption1[1])
						suboption1[2] = Turbine.UI.MenuItem("Percentages",true,Option.per)
						suboption1[2].Click = function ()  Option.per=true Option.txt=false MoraleChanged() PowerChanged() Morale:SetFill(0.8) Power:SetFill(0.8) Morale:SetOpacity(1) Power:SetOpacity(1) end

						contextMenu.SubMenuItems:Add(suboption1[2])
						suboption1[3] = Turbine.UI.MenuItem("None",true,not(Option.txt or Option.per))
						suboption1[3].Click = function () Option.per=false Option.txt=false Morale:SetText("") Power:SetText("") Morale:SetFill(0.8) Power:SetFill(0.8) Morale:SetOpacity(1) Power:SetOpacity(1) end

						contextMenu.SubMenuItems:Add(suboption1[3])
						
				contextMenu.items:Add(option1)
				
				local option2 = Turbine.UI.MenuItem("Full opacity when lost;")
					contextMenu.SubMenuItems = option2:GetItems()
					local suboption2={}
					for i=0,20 do
						--The opacity modifier set the "range" of the fade. For example; at 20% the bar will be at full opacity when 20% is lost, then there is a graduated scale up to invisble at 100%
						 txt=i*5 .. "%"
						if i==0 then txt="Always visible" end
						suboption2[i] = Turbine.UI.MenuItem(txt,true,i*5/100==Option.Opacity)
						suboption2[i].Click = function () Option.Opacity=i*5./100 end

						contextMenu.SubMenuItems:Add(suboption2[i])
					end
				contextMenu.items:Add(option2)
				
				txt="Show"
				if Option.shown then txt="Hide" end
				
				local option3 = Turbine.UI.MenuItem(txt.." default vitals",true)
					option3.Click=function() Option.shown=not(Option.shown) Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Vitals, Option.shown ) end
					
				contextMenu.items:Add(option3)
				

			contextMenu:ShowMenu()
			end
		end
	
	VBarButton.Cover.MouseUp=function(sender,args)
		moving=false
	end
	
	VBarButton.Cover.MouseMove=function(sender,args)
			if moving then
			local x,y=VBarButton.Window:GetMousePosition()

			Option.Scale=math.max(x,y)/32
			if Option.Scale<0.25 then Option.Scale=0.25 end

			VBarButton.Window:SetSize(32*Option.Scale,32*Option.Scale)
			VBarButton.Window.DragBar:Refresh()
		end
	end
	
		function VBarButton.Window:GetWidth()
		return 32*Option.Scale
	end
	function VBarButton.Window:GetHeight()
		return 32*Option.Scale
	end
	function VBarButton.Window:GetSize()
		return 32*Option.Scale ,32*Option.Scale
	end
	
	VBarButton.Window.DragBar:Refresh()
		
	VBarButton.Window.DragEnd=function ()
		Option.X,Option.Y=VBarButton.Window:GetPosition()
	end
	